/* ICt@Cp HTML *//*
*/
importPackage(java.lang, java.io)

function InfHTML(conf, sel) {
  this.resource = conf
  this.init(sel)
}
InfHTML.prototype = {
  init: function (sel) {
    sel = sel? sel +'.': ''
    var resource = this.resource
    if (resource) this.tags = {
      headStart: resource['HTML.'+sel+'head'],
      bodyStart: resource['HTML.'+sel+'body'],
      endTag:    resource['HTML.'+sel+'last'],
    }

    this.nest = []
    this.isPreIn = false

    this.bodyBaos = new ByteArrayOutputStream()
    this.body = new DataOutputStream(this.bodyBaos)
  },

  appendCenterTag: function (cls) {
    if (!this.textAlign) {
      this.textAlign = true
      this.write('<div class="'+cls+'">')
    }
  },
  appendBrTag: function () {
    if (!this.textAlign) {
      this.write(!this.isPreIn? '<br />\n': '\n')
    }
    else {
      this.textAlign = false
      this.write('</div>')
    }
  },
  appendNBSP: function (cls) {
    this.write('<span class="'+cls+'">&nbsp;</span>')
  },

  setTag: function (tag, cls) {
    var attr = cls? ' class="'+cls+'"': ''
    this.write('<' +tag +attr +'>')
    this.nest.push(tag)
  },
  clrTag: function (tag) {
    this.write('</' +tag +'>')
    if (this.nest.join().indexOf(tag) >= 0) {
      // stack topł͂Ȃ, rŌꍇɂbZ[W
      while (this.nest.length > 0 && this.nest.pop() != tag) {}
    }
    else {
      // throw 'Ȃ: '+tag
      print('Ȃ:', tag)
    }
  },
  setPreTag: function () {
    this.setTag('pre', 'prefmt')
    this.isPreIn = true
  },
  clrPreTag: function () {
    this.clrTag('pre')
    this.isPreIn = false
  },
  setMarginLeft: function (n) {
    this.write('<span class="margin">' +n +'</span>')
  },
  setMarginRight: function (n) {
    this.write('<span class="margin"> R:' +n +'</span>')
  },

  write: function (obj) {
    for (var i = 0; i < arguments.length; i++) {
      obj = arguments[i]

      if (obj instanceof Array)
        this.body.write(obj, 0, obj.length)   // byte array
      else if (obj.length > 1)
        this.body.writeBytes(obj)
      else
        this.body.write(obj.charCodeAt())
    }
  },
  conv/* */: function (str) {
    if (typeof str == 'string')
      return str.replace(/&/g, '&amp;').
                 replace(/</g, '&lt;').
                 replace(/>/g, '&gt;')
    //else if (str instanceof Array) {}
    return str
  },

  setTitle: function (title) {
    this.title = this.conv(title)
  },
  writeTo: function (out) {
    var headBaos = new ByteArrayOutputStream()
    var head = new DataOutputStream(headBaos)

    if (this.tags) head.writeBytes(this.tags.headStart)
    if (this.title) {
      head.writeBytes('<title>')
      head.write(this.title, 0, this.title.length)
      head.writeBytes('</title>')
    }
    if (this.tags) head.writeBytes(this.tags.bodyStart)

    head.flush()
    headBaos.writeTo(out)

    this.body.flush()
    this.bodyBaos.writeTo(out)

    if (this.tags) {
      var ba = new java.lang.String(this.tags.endTag).getBytes()
      out.write(ba, 0, ba.length)
    }
  },
}


function InfCodeFx(html) {
  this.breath = true   // 炩̉ŝƂɃZbgB܂Ԃł͕ωȂ ۂ

  this[0xfa] = function () {
    html.write('\n<p>')
    this.breath = true
  }
  this[0xfb] = function () {
    html.appendCenterTag('code-fb')
  }
  this[0xfc] = function () {
    this.breath = !this.breath
  }
  this[0xfd] = function () {
    html.appendBrTag()
    this.breath = true
  }
  this[0xfe] = function () {
    html.appendNBSP('code-fe')
  }

  this.put = function(word) {   // OȂ
    html.write(word)
    if (this.breath && !html.isPreIn)
      html.write(' ')
  }
}


var extLen = [,, 2, 2, 2, 3,, 3, 1,,, 1, 1, 2, 6,,
              , 2, 2, 2, 2,,,, 1, 2, 2, 1, 1,,,]

InfHTML.prototype.ecode = extendedCode

function extendedCode(code, pos, len) {
  var ecode = code[pos]
  var arg1 = code[pos +1] &0xff

  if (len != extLen[ecode]) {
    System.out.print('0x'+code[pos].toString(16) +', ')
    for (var n = 1; n < len; n++)
      System.out.print(code[pos +n] +', ')
    System.out.println()
  }

  // ܂ЂƂ ܂Ƃ܂Ȃ EEE
  switch (ecode) {
  case 0x02:
    this.setMarginLeft(arg1) // 0̏ꍇ
    break;

  case 0x04:
    var attr = ''
    if (arg1 & 0x01) attr += ',E04-0'
    if (arg1 & 0x02) attr += ',E04-1'
    if (arg1 & 0x04) attr += ',E04-2'
    if (attr.length > 0)
      this.setTag('span', attr.substr(1))
    else
      this.clrTag('span')
    break;

  case 0x05:
    var page = code[pos +2] <<8 | code[pos +1] &0xff
    this.write('<a href="./p'+page+'">')
    break;

  case 0x08:
    this.write('</a>')
    break;

  case 0x0b:
    this.setPreTag()
    break;

  case 0x0c:
    this.clrPreTag()
    break;

  case 0x0d:
    if (arg1)
      this.setTag('span', 'E0d-' +arg1)
    else
      this.clrTag('span')
    break;

  case 0x13:
    if (arg1)
      this.setTag('span', 'E13-' +arg1)
    else
      this.clrTag('span')
    break;

  default: //printEcode()
    this.write('<span class="ecode"><span>0x' +ecode.toString(16) +'</span>')
    for (var i = 1; i < len; i++)
      this.write(',' +(code[pos +i] &0xff))
    this.write('</span>')
    break;
  }
}


function unimplement() {
}

/* ȉ, S~, Ȃ̂

  case 0x14:
    if (arg1)
      this.setTag('span', 'E14-' +arg1)
    else
      this.clrTag('span')

  // case 0x0f: html.write('<button>{^', '</button>') break;
  function err(str) { html.write('<span class="err">', str, '</span>') }
  function valchk(str) { if (!eval(str)) err(str) }

*/

function dbg() {
  var res = {
    'HTML.head': '<html><head>',
    'HTML.body': '</head><body>\n',
    'HTML.last': '\n</body></html>',
  }
  var obj = new InfHTML(res)
  obj.write('hello aaa <b> and</b> & amp.')
  obj.writeTo(System.out)
}
